import {
  get
} from "../../utils/http";

// pages/sendFriend/sendFriend.js
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    page: 0, //分页
    limit: 10, //条数
    couponInfo: '', //优惠券名称信息
    coupon_id: '', //优惠券id
    couponRecord: '', //赠送记录
    sendCoupon:'', //是否可以发送优惠券（1可以）
    timesLevel:'', //是否剩余领取次数
    recordId:'' //优惠券记录id
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    wx.hideShareMenu() // 禁止右上角分享好友
    this.getSendCoupon() //获取优惠券名称
    this.scrollToLower() //获取赠送记录
    this.getSendCouponLevel() // 获取是否可以发送优惠券
    this.getTimes() //获取是否剩余次数
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 获取是否有剩余次数
  getTimes(){
    get('/v2/api/send_coupon/hand_out',{},(res)=>{
      if(res.code==200){
        console.log(res);
        this.setData({
          timesLevel:res.data
        })
      }
    })
  },
  // 送优惠券给好友
  onShareFriends() {
    if(this.data.sendCoupon!=1){
      wx.showToast({
        title: '您不满足此次活动要求',
      })
      return
    }
    if(this.data.timesLevel==0){
      wx.showToast({
        title: '没有剩余次数了',
      })
      return
    }
  },

  // 获取赠送优惠券名称
  getSendCoupon() {
    get('/v2/api/send_coupon/active', {}, (res) => {
      if (res.code == 200) {
        this.setData({
          couponInfo: res.data,
          coupon_id: res.data.coupon_id
        },()=>{
          get('/v2/api/send_coupon/send', {
            coupon_id:this.data.coupon_id
          }, (res) => {
            this.setData({
              recordId:res.data
            })
          })
        })
      }
    })
  },
    // 点击分享给好友
    onShareAppMessage() {
      return {
        title: '朋友送你的0元修丽可B5补水还未领取，点击去领取~', // 分享出的卡片标题
        path: `/pages/sendGetCoupon/sendGetCoupon?recordId=${this.data.recordId}`, // 他人通过卡片进入小程序的路径，可以在后面拼接URL的形式带参数
        imageUrl: 'https://we-spa.oss-cn-shenzhen.aliyuncs.com/wxapp/20220922/%E7%BC%96%E7%BB%84%402x.png',
      };
    },
  // 获取赠送记录列表
  scrollToLower() {
    this.setData({
      page: this.data.page + 1
    })
    get('/v2/api/send_coupon/list', {
      page: this.data.page,
      limit: this.data.limit
    }, (res) => {
      let arr = [...res.data, ...this.data.couponRecord]
      this.setData({
        couponRecord: arr
      })
    })
  },
  // 是否可以赠送优惠券
  getSendCouponLevel(){
    get('/v2/api/send_coupon/apply',{},(res)=>{
      this.setData({
        sendCoupon:res.data
      },)
    })
  },
})